'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Card = exports.Image = exports.Button = exports.Link = exports.Heading = exports.Text = exports.Flex = exports.Box = exports.themed = exports.css = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _styledSystem = require('styled-system');

var _cleanTag = require('clean-tag');

var _cleanTag2 = _interopRequireDefault(_cleanTag);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var css = exports.css = function css(props) {
  return props.css;
};
var themed = exports.themed = function themed(key) {
  return function (props) {
    return props.theme[key];
  };
};

var Box = exports.Box = (0, _styledComponents2.default)(_cleanTag2.default)(_styledSystem.space, _styledSystem.width, _styledSystem.fontSize, _styledSystem.flex, _styledSystem.color, themed('Box'), css);

Box.propTypes = _extends({}, _styledSystem.space.propTypes, _styledSystem.width.propTypes, _styledSystem.fontSize.propTypes, _styledSystem.flex.propTypes, _styledSystem.color.propTypes);

var Flex = exports.Flex = (0, _styledComponents2.default)(Box)({
  display: 'flex'
}, _styledSystem.flexWrap, _styledSystem.flexDirection, _styledSystem.alignItems, _styledSystem.justifyContent);

Flex.propTypes = _extends({}, _styledSystem.flexWrap.propTypes, _styledSystem.flexDirection.propTypes, _styledSystem.alignItems.propTypes, _styledSystem.justifyContent.propTypes);

var Text = exports.Text = (0, _styledComponents2.default)(_cleanTag2.default)(_styledSystem.space, _styledSystem.color, _styledSystem.fontSize, _styledSystem.fontFamily, _styledSystem.fontWeight, _styledSystem.textAlign, _styledSystem.lineHeight, _styledSystem.letterSpacing, themed('Text'), css);

Text.propTypes = _extends({}, _styledSystem.space.propTypes, _styledSystem.color.propTypes, _styledSystem.fontSize.propTypes, _styledSystem.fontFamily.propTypes, _styledSystem.fontWeight.propTypes, _styledSystem.textAlign.propTypes, _styledSystem.lineHeight.propTypes, _styledSystem.letterSpacing.propTypes);

var Heading = exports.Heading = (0, _styledComponents2.default)(_cleanTag2.default.h2)(_styledSystem.space, _styledSystem.color, _styledSystem.fontSize, _styledSystem.fontFamily, _styledSystem.fontWeight, _styledSystem.textAlign, _styledSystem.lineHeight, _styledSystem.letterSpacing, themed('Heading'), css);

Heading.propTypes = _extends({}, _styledSystem.space.propTypes, _styledSystem.color.propTypes, _styledSystem.fontSize.propTypes, _styledSystem.fontFamily.propTypes, _styledSystem.fontWeight.propTypes, _styledSystem.textAlign.propTypes, _styledSystem.lineHeight.propTypes, _styledSystem.letterSpacing.propTypes);

Heading.defaultProps = {
  m: 0,
  fontSize: 4,
  fontWeight: 'bold'

  // ditch these
};Heading.h1 = function (props) {
  return _react2.default.createElement(Heading, _extends({ is: 'h1' }, props));
};
Heading.h2 = function (props) {
  return _react2.default.createElement(Heading, _extends({ is: 'h2' }, props));
};
Heading.h3 = function (props) {
  return _react2.default.createElement(Heading, _extends({ is: 'h3' }, props));
};
Heading.h4 = function (props) {
  return _react2.default.createElement(Heading, _extends({ is: 'h4' }, props));
};
Heading.h5 = function (props) {
  return _react2.default.createElement(Heading, _extends({ is: 'h5' }, props));
};
Heading.h6 = function (props) {
  return _react2.default.createElement(Heading, _extends({ is: 'h6' }, props));
};
//

var Link = exports.Link = (0, _styledComponents2.default)(_cleanTag2.default.a)(_styledSystem.space, _styledSystem.fontSize, _styledSystem.color, themed('Heading'), css);

Link.propTypes = _extends({}, _styledSystem.space.propTypes, _styledSystem.fontSize.propTypes, _styledSystem.color.propTypes);

Link.defaultProps = {
  color: 'blue'
};

var Button = exports.Button = (0, _styledComponents2.default)(_cleanTag2.default.button)({
  appearance: 'none',
  display: 'inline-block',
  textAlign: 'center'
}, _styledSystem.space, _styledSystem.fontSize, _styledSystem.fontWeight, _styledSystem.width, _styledSystem.color, _styledSystem.borders, _styledSystem.borderColor, _styledSystem.borderRadius, _styledSystem.buttonStyle, themed('Button'), css);

Button.propTypes = _extends({}, _styledSystem.space.propTypes, _styledSystem.fontSize.propTypes, _styledSystem.fontWeight.propTypes, _styledSystem.width.propTypes, _styledSystem.color.propTypes, _styledSystem.borders.propTypes, _styledSystem.borderColor.propTypes, _styledSystem.borderRadius.propTypes, _styledSystem.buttonStyle.propTypes);

Button.defaultProps = {
  fontSize: 'inherit',
  fontWeight: 'bold',
  m: 0,
  px: 3,
  py: 2,
  color: 'white',
  bg: 'blue',
  border: 0,
  borderRadius: 4
};

var Image = exports.Image = (0, _styledComponents2.default)(_cleanTag2.default.img)({
  maxWidth: '100%',
  height: 'auto'
}, _styledSystem.space, _styledSystem.width, _styledSystem.height, _styledSystem.color, _styledSystem.borderRadius, themed('Image'), css);

Image.propTypes = _extends({}, _styledSystem.space.propTypes, _styledSystem.width.propTypes, _styledSystem.height.propTypes, _styledSystem.color.propTypes, _styledSystem.borderRadius.propTypes);

Image.defaultProps = {
  m: 0
};

var cards = (0, _styledSystem.variant)({ key: 'cards' });

var Card = exports.Card = (0, _styledComponents2.default)(Box)(_styledSystem.borders, _styledSystem.borderRadius, _styledSystem.boxShadow, _styledSystem.backgroundImage, _styledSystem.backgroundSize, _styledSystem.backgroundPosition, _styledSystem.backgroundRepeat, _styledSystem.opacity, themed('Card'), cards, css);

Card.propTypes = {};